import 'dart:convert';
import 'dart:io';
import 'dart:math';

import 'package:flutter_test/flutter_test.dart';
import 'package:healthrian_common_support/healthrian_common_support.dart';

void main() {
  test('data_filter_fir_band_stop', () {
    final dataFilter = DataFilter(1);
    dataFilter.bandStop = BandStop.off;
    dataFilter.highPass = HighPass.off;
    dataFilter.lowPass = LowPass.off;
    dataFilter.firBandStop = FirBandStop.bsf60;
    print(dataFilter.applyFilter(0, 10, true));
  });

  test('data_filter_fir_band_stop_from_file', () {
    final dataFilter = DataFilter(1);
    // dataFilter.bandStop = BandStop.off;
    dataFilter.highPass = HighPass.off;
    dataFilter.lowPass = LowPass.off;
    // dataFilter.firBandStop = FirBandStop.bsf60;

    final input = File('test/input/60hz_noise.json');
    final inputAsString = input.readAsStringSync();
    final inputAsMap = jsonDecode(inputAsString);
    final l2 = inputAsMap['l2'] as List;

    final output = File('test/output/output.txt');

    final buffer = StringBuffer();
    for(final d in l2){
      buffer.write('${dataFilter.applyFilter(0, d, true)}\n');
    }
    output.writeAsStringSync(buffer.toString());
    // for (var i = 0; i < 100; i++) {
    //   print(sin(i/250 * 2 * pi));
    //   // print(dataFilter.applyFilter(0, sin(i / 250 * 2 * pi), true));
    // }
  });
}
